;;; -*- Scheme -*-

#|
Description:
This code tests the invocation of C primitives.

Usage:
(my-char->integer #\@) -> 64
(my-apply + 1 2 3 4) -> 10
(test 'a 'a) -> #t
(test 'a 'b) -> ()
(test-unimpl 'a) -> unimplemented primitive future?
|#

(declare (usual-integrations))

(define (my-char->integer x)
  (char->integer x))

(define (my-apply proc . data)
  (apply proc data))

(define (test x y)
  (my-apply eq? x y))

(let-syntax ((primitive
	      (macro (name arity)
		(make-primitive-procedure name arity))))
  (define (test-unimpl x)
    ((primitive future? 1) x)))